package com.zayac.admin.webapi.system;

import cn.hutool.core.util.ReUtil;
import com.zayac.admin.common.constant.RegexConstants;
import com.zayac.admin.common.util.SecureUtils;
import com.zayac.admin.system.model.query.AccountQuery;
import com.zayac.admin.system.model.req.AccountReq;
import com.zayac.admin.system.model.req.UserReq;
import com.zayac.admin.system.model.resp.AccountDetailResp;
import com.zayac.admin.system.model.resp.AccountResp;
import com.zayac.admin.system.service.AccountService;
import com.zayac.admin.system.service.PlatformService;
import lombok.RequiredArgsConstructor;
import org.springframework.validation.annotation.Validated;
import top.continew.starter.core.util.ExceptionUtils;
import top.continew.starter.core.util.validate.ValidationUtils;
import top.continew.starter.extension.crud.enums.Api;

import io.swagger.v3.oas.annotations.tags.Tag;

import org.springframework.web.bind.annotation.*;

import top.continew.starter.extension.crud.annotation.CrudRequestMapping;
import top.continew.starter.extension.crud.controller.BaseController;
import top.continew.starter.extension.crud.util.ValidateGroup;
import top.continew.starter.web.model.R;


/**
 * 账号管理 API
 *
 * @author zayac
 * @since 2024/05/10 20:44
 */
@Tag(name = "账号管理 API")
@RestController
@CrudRequestMapping(value = "/system/account", api = {Api.PAGE, Api.GET, Api.ADD, Api.UPDATE, Api.DELETE, Api.EXPORT})
@RequiredArgsConstructor
public class AccountController extends BaseController<AccountService, AccountResp, AccountDetailResp, AccountQuery, AccountReq> {
    private final PlatformService platformService;

/*    @Override
    public R<Long> add(@Validated(ValidateGroup.Crud.Add.class) @RequestBody AccountReq req) {
//        String rawPassword = ExceptionUtils.exToNull(() -> SecureUtils.decryptByRsaPrivateKey(req.getPassword()));
//        ValidationUtils.throwIfNull(rawPassword, "密码解密失败");
        ValidationUtils.throwIf(!ReUtil
                .isMatch(RegexConstants.PASSWORD, req.getPassword()), "密码长度为 6 到 32 位，可以包含字母、数字、下划线，特殊字符，同时包含字母和数字");
        req.setPlatformId(platformService.getByPlatformId(req.getType().getValue()).getId());
        return super.add(req);
    }

    @Override
    public R<Void> update(@Validated(ValidateGroup.Crud.Update.class) @RequestBody AccountReq req, @PathVariable Long id) {
//        String rawPassword = ExceptionUtils.exToNull(() -> SecureUtils.decryptByRsaPrivateKey(req.getPassword()));
//        ValidationUtils.throwIfNull(rawPassword, "密码解密失败");
        ValidationUtils.throwIf(!ReUtil
                .isMatch(RegexConstants.PASSWORD, req.getPassword()), "密码长度为 6 到 32 位，可以包含字母、数字、下划线，特殊字符，同时包含字母和数字");
        req.setPlatformId(platformService.getByPlatformId(req.getType().getValue()).getId());
        return super.update(req, id);
    }*/

}